/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/

/*
 $Log: not supported by cvs2svn $
 Revision 1.2  1995/09/05 21:16:53  saunders
 First test release of the SDDS1.5 package.

*/

/* routine: bomb()
 * purpose: report messages to terminal and abort.
 * usage:
 *  bomb(error_description, usage_description)
 *  char *error_description, *usage_description;
 */
#include "mdb.h"

void bomb(char *error, char *usage) {
  if (error)
    fprintf(stderr, "error: %s\n", error);
  if (usage)
    fprintf(stderr, "usage: %s\n", usage);
  exit(1);
}

long bombre(char *error, char *usage, long return_value) {
  if (error)
    fprintf(stderr, "error: %s\n", error);
  if (usage)
    fprintf(stderr, "usage: %s\n", usage);
  return return_value;
}

/* This version accepts a printf-style template and variable number of arguments to be printed */
void bombVA(char *template, ...) {
  char *p;
  char c, *s;
  int i;
  long j;
  va_list argp;
  double d;

  va_start(argp, template);
  p = template;
  while (*p) {
    if (*p == '%') {
      switch (*++p) {
      case 'l':
        switch (*++p) {
        case 'd':
          j = va_arg(argp, long int);
          printf("%ld", j);
          break;
        case 'e':
          d = va_arg(argp, double);
          printf("%21.15le", d);
          break;
        case 'f':
          d = va_arg(argp, double);
          printf("%lf", d);
          break;
        case 'g':
          d = va_arg(argp, double);
          printf("%21.15lg", d);
          break;
        default:
          printf("%%l%c", *p);
          break;
        }
        break;
      case 'c':
        c = va_arg(argp, int);
        putchar(c);
        break;
      case 'd':
        i = va_arg(argp, int);
        printf("%d", i);
        break;
      case 's':
        s = va_arg(argp, char *);
        fputs(s, stdout);
        break;
      case 'e':
        d = va_arg(argp, double);
        printf("%21.15e", d);
        break;
      case 'f':
        d = va_arg(argp, double);
        printf("%f", d);
        break;
      case 'g':
        d = va_arg(argp, double);
        printf("%21.15g", d);
        break;
      default:
        printf("%%%c", *p);
        break;
      }
    } else {
      putchar(*p);
    }
    p++;
  }
  va_end(argp);
  exit(1);
}
